// note to self: compile with
// C:\WINDOWS\Microsoft.NET\Framework\v2.0.50727\csc get.cs

using System;
using System.IO;
using System.IO.Ports;

class blah
{
static void Main( string [] args )
{
  try
  {
    if( args.Length != 2 )
    {
      Console.WriteLine("usage: get portname filename");
      return;
    }
    GetFile( args[0], args[1] );
  }
  catch( Exception e )
  {
    Console.WriteLine( e );
  }
}

static void GetFile( string portname, string filename )
{
  SerialPort port = new SerialPort( portname, 19200, Parity.None, 8, StopBits.One);
  byte [] buffer = new byte[1024];

  FileStream fs = new FileStream( filename, FileMode.Create );
  BinaryWriter bw = new BinaryWriter( fs );
  
  port.Open();
  port.ReadTimeout = 500;
  
  port.Write( "G" );
  port.Write( filename );
  port.Write( new byte [] {0}, 0, 1 );
  if( port.ReadByte() != 'A' )
    throw new Exception( "no ack from prop" );

  int n = 0;
  int blksize;
  do
  {
    blksize = (byte)port.ReadByte();
    blksize += (byte)port.ReadByte() << 8;

    Console.Write( "." );
    byte chksum = 0;
    for( int i=0; i<blksize; ++i )
    {
      buffer[i] = (byte)port.ReadByte();
      chksum += buffer[i];
    }
    n += blksize;
    bw.Write( buffer, 0, blksize );
    port.Write( new byte [] {chksum}, 0, 1 );
  }
  while( blksize == 1024 );

  Console.WriteLine();
  port.Close();

  Console.WriteLine( "{0} bytes received", n );
}
}