// note to self: compile with
// C:\WINDOWS\Microsoft.NET\Framework\v2.0.50727\csc put.cs

using System;
using System.IO;
using System.IO.Ports;

class blah
{
static void Main( string [] args )
{
  try
  {
    Put( args );
  }
  catch( Exception e )
  {
    Console.WriteLine( e );
  }
}

static void Put( string[] args )
{
  if( args.Length < 2 || args.Length > 3 )
    throw new Exception( "usage: put port file1 [file2]" );
  string portname = args[0];
  string file1 = args[1];
  string file2 = file1;
  if( args.Length == 3 )
  {
    file2 = args[2];
  }
  else
  {
    file2 = file2.ToLower();
    if( file2.EndsWith( ".binary" ) )
    {
      file2 = file2.Substring( 0, file2.Length-3 );
    }
    else if( file2.EndsWith( ".eeprom" ) )
    {
      file2 = file2.Substring( 0, file2.Length-3 );
    }
    if( file2.EndsWith( ".spin" ) )
    {
      file2 = file2.Substring( 0, file2.Length-4 ) + "spn";
    }
    Console.WriteLine( file2 );
  }
  PutFile( portname, file1, file2 );
}

static void PutFile( string portname, string infilename, string outfilename )
// infilename is filename on PC's disk
// outfilename is 8.3 filename on the Propeller side
{
  SerialPort port = new SerialPort( portname, 19200, Parity.None, 8, StopBits.One );
  byte [] buffer = new byte[1024];

  FileStream fs = new FileStream( infilename, FileMode.Open );
  BinaryReader br = new BinaryReader( fs );
  
  port.Open();
  port.ReadTimeout = 500;
  
  port.Write( "P" );
  port.Write( outfilename );
  port.Write( new byte [] {0}, 0, 1 );
  if( port.ReadByte() != 'A' )
    throw new Exception( "no ack from prop" );

  int n = 0;
  int blksize;
  do
  {
    blksize = br.Read( buffer, 0, 1024 );
    port.Write( new byte [] { (byte)blksize, (byte)(blksize>>8) }, 0, 2 );

    Console.Write( "." );;;
    port.Write( buffer, 0, blksize );
    byte chksum = 0;
    for( int i=0; i<blksize; ++i )
    {
      chksum += buffer[i];
    }
    n += blksize;
    if( chksum != port.ReadByte() )
      throw new Exception( "checksum error" );
  }
  while( blksize == 1024 );

  port.Close();

  Console.WriteLine( "{0} bytes sent", n );
}
}